spago-0.21.0

Safe Haskell | None
Language | Haskell2010

Spago.NewConfig

# Documentation

data NewConfig #

Constructors

NewConfig |

Fields

- package :: PackageConfig
- workspace :: WorkspaceConfig

#### Instances

Instances details

ToJSON NewConfig # |
Instance details Defined in Spago.NewConfig Methods toJSON :: NewConfig -> Value # toEncoding :: NewConfig -> Encoding # toJSONList :: [NewConfig] -> Value # toEncodingList :: [NewConfig] -> Encoding # omitField :: NewConfig -> Bool #

data PackageConfig #

Constructors

PackageConfig |

Fields

- name :: Text
- publish :: Maybe NewPublishConfig
- dependencies :: Set PackageName

#### Instances

Instances details

ToJSON PackageConfig # |
Instance details Defined in Spago.NewConfig Methods toJSON :: PackageConfig -> Value # toEncoding :: PackageConfig -> Encoding # toJSONList :: [PackageConfig] -> Value # toEncodingList :: [PackageConfig] -> Encoding # omitField :: PackageConfig -> Bool #
Generic PackageConfig # |

Instance details

Defined in Spago.NewConfig

Associated Types

type Rep PackageConfig |

Instance details

Defined in Spago.NewConfig

type Rep PackageConfig = D1 ('MetaData "PackageConfig" "Spago.NewConfig" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "PackageConfig" 'PrefixI 'True) (S1 ('MetaSel ('Just "name") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text) :*: (S1 ('MetaSel ('Just "publish") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe NewPublishConfig)) :*: S1 ('MetaSel ('Just "dependencies") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Set PackageName)))))

Methods

from :: PackageConfig -> Rep PackageConfig x #

to :: Rep PackageConfig x -> PackageConfig #

type Rep PackageConfig # |

Instance details

Defined in Spago.NewConfig

type Rep PackageConfig = D1 ('MetaData "PackageConfig" "Spago.NewConfig" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "PackageConfig" 'PrefixI 'True) (S1 ('MetaSel ('Just "name") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text) :*: (S1 ('MetaSel ('Just "publish") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe NewPublishConfig)) :*: S1 ('MetaSel ('Just "dependencies") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Set PackageName)))))

data NewPublishConfig #

Constructors

NewPublishConfig |

Fields

- version :: Maybe Text
- license :: Maybe Text

#### Instances

Instances details

ToJSON NewPublishConfig # |
Instance details Defined in Spago.NewConfig Methods toJSON :: NewPublishConfig -> Value # toEncoding :: NewPublishConfig -> Encoding # toJSONList :: [NewPublishConfig] -> Value # toEncodingList :: [NewPublishConfig] -> Encoding # omitField :: NewPublishConfig -> Bool #
Generic NewPublishConfig # |

Instance details

Defined in Spago.NewConfig

Associated Types

type Rep NewPublishConfig |

Instance details

Defined in Spago.NewConfig

type Rep NewPublishConfig = D1 ('MetaData "NewPublishConfig" "Spago.NewConfig" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "NewPublishConfig" 'PrefixI 'True) (S1 ('MetaSel ('Just "version") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe Text)) :*: S1 ('MetaSel ('Just "license") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe Text))))

Methods

from :: NewPublishConfig -> Rep NewPublishConfig x #

to :: Rep NewPublishConfig x -> NewPublishConfig #

type Rep NewPublishConfig # |

Instance details

Defined in Spago.NewConfig

type Rep NewPublishConfig = D1 ('MetaData "NewPublishConfig" "Spago.NewConfig" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "NewPublishConfig" 'PrefixI 'True) (S1 ('MetaSel ('Just "version") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe Text)) :*: S1 ('MetaSel ('Just "license") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe Text))))

data ExtraPackage #

Constructors

ExtraPackage |

Fields

- git :: Text
- ref :: Text
- dependencies :: Set PackageName

#### Instances

Instances details

ToJSON ExtraPackage # |
Instance details Defined in Spago.NewConfig Methods toJSON :: ExtraPackage -> Value # toEncoding :: ExtraPackage -> Encoding # toJSONList :: [ExtraPackage] -> Value # toEncodingList :: [ExtraPackage] -> Encoding # omitField :: ExtraPackage -> Bool #
Generic ExtraPackage # |

Instance details

Defined in Spago.NewConfig

Associated Types

type Rep ExtraPackage |

Instance details

Defined in Spago.NewConfig

type Rep ExtraPackage = D1 ('MetaData "ExtraPackage" "Spago.NewConfig" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "ExtraPackage" 'PrefixI 'True) (S1 ('MetaSel ('Just "git") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text) :*: (S1 ('MetaSel ('Just "ref") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text) :*: S1 ('MetaSel ('Just "dependencies") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Set PackageName)))))

Methods

from :: ExtraPackage -> Rep ExtraPackage x #

to :: Rep ExtraPackage x -> ExtraPackage #

type Rep ExtraPackage # |

Instance details

Defined in Spago.NewConfig

type Rep ExtraPackage = D1 ('MetaData "ExtraPackage" "Spago.NewConfig" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "ExtraPackage" 'PrefixI 'True) (S1 ('MetaSel ('Just "git") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text) :*: (S1 ('MetaSel ('Just "ref") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text) :*: S1 ('MetaSel ('Just "dependencies") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Set PackageName)))))

data BackendConfig #

Constructors

BackendConfig |

Fields

- cmd :: Text

#### Instances

Instances details

ToJSON BackendConfig # |
Instance details Defined in Spago.NewConfig Methods toJSON :: BackendConfig -> Value # toEncoding :: BackendConfig -> Encoding # toJSONList :: [BackendConfig] -> Value # toEncodingList :: [BackendConfig] -> Encoding # omitField :: BackendConfig -> Bool #
Generic BackendConfig # |

Instance details

Defined in Spago.NewConfig

Associated Types

type Rep BackendConfig |
Instance details Defined in Spago.NewConfig type Rep BackendConfig = D1 ('MetaData "BackendConfig" "Spago.NewConfig" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "BackendConfig" 'PrefixI 'True) (S1 ('MetaSel ('Just "cmd") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text)))

Methods

from :: BackendConfig -> Rep BackendConfig x #

to :: Rep BackendConfig x -> BackendConfig #

type Rep BackendConfig # |
Instance details Defined in Spago.NewConfig type Rep BackendConfig = D1 ('MetaData "BackendConfig" "Spago.NewConfig" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "BackendConfig" 'PrefixI 'True) (S1 ('MetaSel ('Just "cmd") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text)))

data WorkspaceConfig #

Constructors

WorkspaceConfig |

Fields

- package_set :: PackageSetAddress
- backend :: Maybe BackendConfig
- extra_packages :: Map PackageName ExtraPackage

#### Instances

Instances details

ToJSON WorkspaceConfig # |
Instance details Defined in Spago.NewConfig Methods toJSON :: WorkspaceConfig -> Value # toEncoding :: WorkspaceConfig -> Encoding # toJSONList :: [WorkspaceConfig] -> Value # toEncodingList :: [WorkspaceConfig] -> Encoding # omitField :: WorkspaceConfig -> Bool #
Generic WorkspaceConfig # |

Instance details

Defined in Spago.NewConfig

Associated Types

type Rep WorkspaceConfig |

Instance details

Defined in Spago.NewConfig

type Rep WorkspaceConfig = D1 ('MetaData "WorkspaceConfig" "Spago.NewConfig" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "WorkspaceConfig" 'PrefixI 'True) (S1 ('MetaSel ('Just "package_set") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 PackageSetAddress) :*: (S1 ('MetaSel ('Just "backend") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe BackendConfig)) :*: S1 ('MetaSel ('Just "extra_packages") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Map PackageName ExtraPackage)))))

Methods

from :: WorkspaceConfig -> Rep WorkspaceConfig x #

to :: Rep WorkspaceConfig x -> WorkspaceConfig #

type Rep WorkspaceConfig # |

Instance details

Defined in Spago.NewConfig

type Rep WorkspaceConfig = D1 ('MetaData "WorkspaceConfig" "Spago.NewConfig" "spago-0.21.0-7fGZ7CPhD6UKUhYlrl5wZv" 'False) (C1 ('MetaCons "WorkspaceConfig" 'PrefixI 'True) (S1 ('MetaSel ('Just "package_set") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 PackageSetAddress) :*: (S1 ('MetaSel ('Just "backend") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Maybe BackendConfig)) :*: S1 ('MetaSel ('Just "extra_packages") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (Map PackageName ExtraPackage)))))

newtype PackageSetAddress #

Constructors

PackageSetAddress Text |

#### Instances

Instances details

ToJSON PackageSetAddress # |
Instance details Defined in Spago.NewConfig Methods toJSON :: PackageSetAddress -> Value # toEncoding :: PackageSetAddress -> Encoding # toJSONList :: [PackageSetAddress] -> Value # toEncodingList :: [PackageSetAddress] -> Encoding # omitField :: PackageSetAddress -> Bool #

customOptions :: Options #

toExtraPackage :: Package -> Maybe ExtraPackage #

migrate :: (HasLogFunc env, HasConfig env) => RIO env () #

renderUrl :: URL -> Text #